﻿Module ShellSorter

    ' Das ist alles!

    Public Sub ShellSort(Of T)(ByVal Data() As T, ByVal Comp As Comparison(Of T), ByVal GapFunc As GapFunction)
        Dim Tmp As T ' Temporäres Element
        Dim Len = Data.Length ' Länge des Arrays
        Dim Pos As Integer ' Aktuelle Einfügeposition
        Dim Cols = GapFunc(Len) ' Die Gap-Sequenz evaluieren

        ' Alle Gaps durchlaufen
        For Each h In Cols
            ' Alle Elemente von h ab durchlaufen
            For i = h To Len - 1

                Tmp = Data(i)
                Pos = i

                ' Einfügeposition suchen und so lange die zu großen Elemente nach rechts verschieben
                Do Until (Pos < h) OrElse (Comp(Data(Pos - h), Tmp) > 0)
                    Data(Pos) = Data(Pos - h)
                    Pos -= h
                Loop

                ' Einfügen
                Data(Pos) = Tmp
            Next
        Next
    End Sub

End Module
